import java.util.Map;
import java.util.Scanner;

import java.util.ArrayList;
import java.util.Base64;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.UnsupportedEncodingException;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.ParseException;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import com.google.gson.Gson;

import OfdCreatorParam.WebClientImageItem;
import OfdCreatorParam.WebClientInputParam;
import OfdCreatorParam.WebClientOutputParam;
import OfdCreatorParam.WebClientPage;
import OfdCreatorParam.WebClientTextItem;
import OfdExtraction.InvoiceData;
import OfdExtraction.OfdDataExtractionInfo;
import OfdExtraction.OfdExtractionFileInput;
import OfdExtraction.OfdExtractionInput;
import OfdExtraction.OfdExtractionOutput;
import OfdPrinterParam.OfdPrinterFileInput;
import OfdPrinterParam.OfdPrinterFileOutput;
import OfdPrinterParam.OfdPrinterInput;
import OfdPrinterParam.OfdPrinterOutput;
import OfdPrinterParam.OfdPrinterParam;

import OfdToPdfParam.OfdFileInput;
import OfdToPdfParam.OfdFileOutput;
import OfdToPdfParam.OfdToPdfInput;
import OfdToPdfParam.OfdToPdfOutput;
import OfdToPdfParam.WatermarkText;
import OfdToPdfParam.WatermarkImage;

import OfdToPicParam.OfdDrawingFileInput;
import OfdToPicParam.OfdDrawingFileOutput;
import OfdToPicParam.OfdDrawingInput;
import OfdToPicParam.OfdDrawingOutput;
import OfdVerification.OfdDataVerificationInfo;
import OfdVerification.OfdVerificationFileInput;
import OfdVerification.OfdVerificationInput;
import OfdVerification.OfdVerificationOutput;

public class MainApp {

	// ʾ : ofdתͼƬofdתpdfofdɡofdӡƱȡ֤ǩ ȹܵʾ
	// ҪοӦĴ롣
	public static void main(String[] args) {

		// 1: ofdתͼƬ
		// OfdToPic();

		// 2: ofdתpdf
		// OfdToPdf();

		// 3: ģofd
		// CreatOfd();

		// 4: ofdӡ
		// PrintOfd();

		// 5: ȡ ԷƱ
		// OfdDataExtraction();

		// 6֤ǩ
		OfdVerification();
	}

	// region 1ofdתͼƬʾ *************************************************
	public static void OfdToPic() {
		// תͼӿڵʾ
		System.out.println("OfdToPic start");

		// ofdļ ע⣺ļʵ
		String ofdFileName = "test.ofd";

		// ofdתͼ ַ ע⣺Ҫдʵķַ
		String serverUrl = "http://localhost:9400/OfdDrawing";

		// 
		Map<String, String> params = new HashMap<String, String>();
		OfdDrawingInput inputParam = CreateOfdToPicParam(ofdFileName);

		Gson gson = new Gson();
		String paramValueJson = gson.toJson(inputParam);
		params.put("input", paramValueJson);

		// web api 
		String httpResponse = post_method(params, serverUrl);

		//  jsonл
		OfdDrawingOutput outParam = gson.fromJson(httpResponse, OfdDrawingOutput.class);

		OfdDrawingFileOutput fileOutput = outParam.ListOfdFileOutput.get(0);
		if (fileOutput.OK) {
			System.out.println("ɳɹ" + fileOutput.FileName + ":" + fileOutput.OfdFileID);

			// һofdпתΪҳͼƬ
			for (int i = 0; i < fileOutput.ListPageDataBase64.size(); i++) {
				String imageData = fileOutput.ListPageDataBase64.get(i);
				byte[] ofdBuffer = Base64.getDecoder().decode(imageData);

				try {
					String picFileName = String.format("image%d.png", i + 1);
					deleteFile(picFileName);

					BufferedOutputStream out = null;
					try {
						out = new BufferedOutputStream(new FileOutputStream(picFileName, false));
						out.write(ofdBuffer);
						System.out.println("ͼƬļɹ" + picFileName);
					} finally {
						if (out != null) {
							out.close();
						}
					}
				} catch (Exception e) {
				}
			}
		} else {
			System.out.println("ʧܣ" + fileOutput.Message);
		}

		System.out.println("OfdToPic end");
	}

	// ofdתͼƬ 
	private static OfdDrawingInput CreateOfdToPicParam(String ofdFileName) {
		OfdDrawingInput result = new OfdDrawingInput();
		result.ClientData = "ͻ˱ʶ";
		result.ListOfdFileInput = new ArrayList<OfdDrawingFileInput>();

		OfdDrawingFileInput ofdFileInput = GetOfdDrawingFileInput(ofdFileName);
		result.ListOfdFileInput.add(ofdFileInput);
		return result;
	}

	// ofdתͼƬ ĳofdļ 
	private static OfdDrawingFileInput GetOfdDrawingFileInput(String ofdFileName) {

		OfdDrawingFileInput result = new OfdDrawingFileInput();
		result.FileName = ofdFileName;
		result.OfdFileID = "123456";
		result.ImageScale = 1; // ͼƬű
		result.OfdFileDataBase64 = GetFileBase64(ofdFileName);

		// ˮӡ
		result.WatermarkTextGroup = new ArrayList<WatermarkText>();
		WatermarkText watermarkText = new WatermarkText();

		watermarkText.PageNum = 0;
		watermarkText.Text = "ˮӡ";
		watermarkText.FontName = "";
		watermarkText.FontSize = 9;
		watermarkText.FontColor = -65536;

		watermarkText.X = 23;
		watermarkText.Y = 140;
		watermarkText.HorizontalAlignment = 0;
		watermarkText.VerticalAlignment = 0;
		watermarkText.RotationDegree = 20;

		watermarkText.BackgroundFillColor = 2130739328;
		watermarkText.BackgroundPadding = "2,2,2,2";
		watermarkText.BackgroundLineWidth = 1;
		watermarkText.BackgroundLineColor = -16777216;

		result.WatermarkTextGroup.add(watermarkText);

		// ͼƬˮӡ
		result.WatermarkImageGroup = new ArrayList<WatermarkImage>();

		WatermarkImage watermarkImage = new WatermarkImage();
		watermarkImage.PageNum = 0;
		watermarkImage.X = 15;
		watermarkImage.Y = 40;
		watermarkImage.Width = 30;
		watermarkImage.Height = 21;
		watermarkImage.RotationDegree = -10;
		watermarkImage.ImageDataBase64 = GetFileBase64("water.png");
		result.WatermarkImageGroup.add(watermarkImage);

		return result;
	}
	// endregion ofdתͼƬʾ

	// region:2תpdfӿڵʾ *************************************************
	public static void OfdToPdf() {

		System.out.println("OfdToPdf start");

		// ofdļ ע⣺ļʵ
		String ofdFileName = "test.ofd";

		// ofdתpdf ַ ע⣺Ҫдʵķַ
		String serverUrl = "http://localhost:9300/OfdFileToPdf";

		// 
		Map<String, String> params = new HashMap<String, String>();
		OfdToPdfInput inputParam = CreateOfdToPdfParam(ofdFileName);

		Gson gson = new Gson();
		String paramValueJson = gson.toJson(inputParam);

		params.put("input", paramValueJson);
		String httpResponse = post_method(params, serverUrl);

		OfdToPdfOutput outParam = gson.fromJson(httpResponse, OfdToPdfOutput.class);

		OfdFileOutput fileOutput = outParam.ListOfdFileOutput.get(0);
		if (fileOutput.OK) {
			System.out.println("ɳɹ" + fileOutput.FileName + ":" + fileOutput.OfdFileID);

			Base64.Decoder decoder = Base64.getDecoder();

			byte[] ofdBuffer = decoder.decode(fileOutput.PdfDataBase64);

			try {
				String pdfFileName = "test.pdf";
				deleteFile(pdfFileName);

				BufferedOutputStream out = null;
				try {
					out = new BufferedOutputStream(new FileOutputStream(pdfFileName, false));
					out.write(ofdBuffer);
					System.out.println("pdfļɹ" + pdfFileName);
				} finally {
					if (out != null) {
						out.close();
					}
				}

			} catch (Exception e) {
			}
		} else {
			System.out.println("ʧܣ" + fileOutput.Message);
		}

		System.out.println("end");

	}

	// ofdתpdf 
	static OfdToPdfInput CreateOfdToPdfParam(String ofdFileName) {
		OfdToPdfInput result = new OfdToPdfInput();
		result.ClientData = "ͻ˱ʶ";
		result.ListOfdFileInput = new ArrayList<OfdFileInput>();

		OfdFileInput ofdFileInput = GetOfdFileInput(ofdFileName);
		result.ListOfdFileInput.add(ofdFileInput);
		return result;
	}

	// ofdתpdf ĳofdļ 
	static OfdFileInput GetOfdFileInput(String ofdFileName) {
		OfdFileInput result = new OfdFileInput();
		result.FileName = "ofdfilename";
		result.OfdFileID = "1234566";

		result.OfdFileDataBase64 = GetFileBase64(ofdFileName);

		// ˮӡ
		result.WatermarkTextGroup = new ArrayList<WatermarkText>();
		WatermarkText watermarkText = new WatermarkText();

		watermarkText.PageNum = 0;
		watermarkText.Text = "ˮӡ";
		watermarkText.FontName = "";
		watermarkText.FontSize = 9;
		watermarkText.FontColor = -65536;

		watermarkText.X = 23;
		watermarkText.Y = 140;
		watermarkText.HorizontalAlignment = 0;
		watermarkText.VerticalAlignment = 0;
		watermarkText.RotationDegree = 20;

		watermarkText.BackgroundFillColor = 2130739328;
		watermarkText.BackgroundPadding = "2,2,2,2";
		watermarkText.BackgroundLineWidth = 1;
		watermarkText.BackgroundLineColor = -16777216;

		result.WatermarkTextGroup.add(watermarkText);

		// ͼƬˮӡ
		result.WatermarkImageGroup = new ArrayList<WatermarkImage>();

		WatermarkImage watermarkImage = new WatermarkImage();
		watermarkImage.PageNum = 0;
		watermarkImage.X = 15;
		watermarkImage.Y = 40;
		watermarkImage.Width = 30;
		watermarkImage.Height = 21;
		watermarkImage.RotationDegree = -10;
		watermarkImage.ImageDataBase64 = GetFileBase64("water.png");
		result.WatermarkImageGroup.add(watermarkImage);

		return result;
	}

	// region:3ofdӿڵʾ *************************************************
	public static void CreatOfd() {

		System.out.println("CreatOfd start");

		// ˵ַ
		String serverUrl = "http://localhost:9100/OfdCreator";

		// ɽ֤֤ ʾע⣺ڲ֤ͬգӦ֤ģ塣ͻ˵ôƣֻidͶӦֵ
		Map<String, String> params = new HashMap<String, String>();
		WebClientInputParam inputParam = CreateMarriageCert();

		Gson gson = new Gson();
		String paramValueJson = gson.toJson(inputParam);
		System.out.println(paramValueJson);

		params.put("input", paramValueJson);

		String httpResponse = post_method(params, serverUrl);

		WebClientOutputParam outParam = gson.fromJson(httpResponse, WebClientOutputParam.class);
		if (outParam.OK) {
			System.out.println("ɳɹ" + httpResponse);

			Base64.Decoder decoder = Base64.getDecoder();
			byte[] ofdBuffer = decoder.decode(outParam.OfdFileDataBase64);

			try {
				String ofdFileName = "javaCreat.ofd";
				deleteFile(ofdFileName);

				BufferedOutputStream out = null;
				try {
					out = new BufferedOutputStream(new FileOutputStream(ofdFileName, false));
					out.write(ofdBuffer);
					System.out.println("ofdļɹ" + ofdFileName);
				} finally {
					if (out != null) {
						out.close();
					}
				}

			} catch (Exception e) {
			}
		} else {
			System.out.println("ʧܣ" + outParam.Message);
		}

		System.out.println("CreatOfd end");

	}

	// ɽ֤
	private static WebClientInputParam CreateMarriageCert() {
		WebClientInputParam clientParam = new WebClientInputParam();
		// ģid ע⣺ȷжӦģļ
		clientParam.TemplateGuid = "5041075d-a3d3-462e-b4b2-c3a9cfb18c8d";
		clientParam.ClientData = "ͻ˷͵,ԭ";

		clientParam.PageGroup = new ArrayList<WebClientPage>();

		// ģֻһҳֻҪһҳ
		WebClientPage page = CreateOfdPage(0);
		clientParam.PageGroup.add(page);

		return clientParam;
	}

	private static WebClientPage CreateOfdPage(int templatePageIndex) {
		WebClientPage page = new WebClientPage();
		page.TemplatePageIndex = templatePageIndex;// Ӧģļoftҳ

		page.ListPageText = new ArrayList<WebClientTextItem>();
		page.ListPageImage = new ArrayList<WebClientImageItem>();

		// ֤
		WebClientTextItem item = new WebClientTextItem();
		item.Guid = "*5";
		item.DataValue = "";
		page.ListPageText.add(item);

		// Ǽ
		item = new WebClientTextItem();
		item.Guid = "*7";
		item.DataValue = "2020-08-16";
		page.ListPageText.add(item);

		// ֺ֤
		item = new WebClientTextItem();
		item.Guid = "*9";
		item.DataValue = "J330302-2020-1234567";
		page.ListPageText.add(item);

		// ע
		item = new WebClientTextItem();
		item.Guid = "*11";
		item.DataValue = "䷢ĵ֤,ֽ֤ͬȷЧ";
		page.ListPageText.add(item);

		// з
		item = new WebClientTextItem();
		item.Guid = "*15";
		item.DataValue = "һ";
		page.ListPageText.add(item);

		// з
		item = new WebClientTextItem();
		item.Guid = "*17";
		item.DataValue = "й";
		page.ListPageText.add(item);

		// з
		item = new WebClientTextItem();
		item.Guid = "*19";
		item.DataValue = "1998-09-08";
		page.ListPageText.add(item);

		// з֤
		item = new WebClientTextItem();
		item.Guid = "*21";
		item.DataValue = "3700000000002020";
		page.ListPageText.add(item);

		// Ů
		item = new WebClientTextItem();
		item.Guid = "*23";
		item.DataValue = "";
		page.ListPageText.add(item);

		// Ů
		item = new WebClientTextItem();
		item.Guid = "*25";
		item.DataValue = "";
		page.ListPageText.add(item);

		// Ů
		item = new WebClientTextItem();
		item.Guid = "*27";
		item.DataValue = "1999-12-02";
		page.ListPageText.add(item);

		// Ů֤
		item = new WebClientTextItem();
		item.Guid = "*29";
		item.DataValue = "49000000001999";
		page.ListPageText.add(item);

		/********************* ͼƬ *********************/

		// ά
		File qrFile = new File("./֤ά.png");
		if (qrFile.exists()) {
			try {

				FileInputStream in = new FileInputStream(qrFile);
				byte[] imageBuffer = in.readAllBytes();

				Base64.Encoder encoder = Base64.getEncoder();
				String encodedText = encoder.encodeToString(imageBuffer);

				WebClientImageItem image = new WebClientImageItem();
				image.Guid = "*31";
				image.DataValue = encodedText;
				image.ImageExt = ".png";
				page.ListPageImage.add(image);
			} catch (Exception e) {
			}
		}

		// ӰƬ
		File photoFile = new File("֤Ӱ.png");
		if (photoFile.exists()) {
			try {
				FileInputStream in = new FileInputStream(photoFile);
				byte[] imageBuffer = in.readAllBytes();

				Base64.Encoder encoder = Base64.getEncoder();
				String encodedText = encoder.encodeToString(imageBuffer);

				WebClientImageItem image = new WebClientImageItem();
				image.Guid = "*13";
				image.DataValue = encodedText;
				image.ImageExt = ".png";
				page.ListPageImage.add(image);

				in.close();
			} catch (Exception e) {
			}
		}

		return page;
	}
	// endregion

	// region:4ofdӡ ӿڵʾ *************************************************
	static void PrintOfd() {
		// תͼӿڵʾ
		System.out.println("PrintOfd start");

		// ofdļ ע⣺ļʵ
		String ofdFileName = "Ʊ.ofd";

		// ofdӡ ַ ע⣺Ҫдʵķַ
		String serverUrl = "http://localhost:9500/OfdPrinter";

		// 
		Map<String, String> params = new HashMap<String, String>();
		OfdPrinterInput inputParam = CreateOfdToPrintParam(ofdFileName);

		Gson gson = new Gson();
		String paramValueJson = gson.toJson(inputParam);
		params.put("input", paramValueJson);

		// web api 
		String httpResponse = post_method(params, serverUrl);

		//  jsonл
		OfdPrinterOutput outParam = gson.fromJson(httpResponse, OfdPrinterOutput.class);

		OfdPrinterFileOutput fileOutput = outParam.ListOfdFileOutput.get(0);
		if (fileOutput.OK) {
			System.out.println("ʹӡɹ");
		} else {
			System.out.println("ʹӡʧܣ" + fileOutput.Message);
		}

		System.out.println("PrintOfd end");
	}

	private static OfdPrinterInput CreateOfdToPrintParam(String ofdFileName) {

		OfdPrinterInput inputParam = new OfdPrinterInput();
		inputParam.ClientData = "ͻ˷͵tag ԭ";

		OfdPrinterFileInput ofdFileInput = new OfdPrinterFileInput();
		String fileDataBase64 = GetFileBase64(ofdFileName);

		ofdFileInput.FileName = ofdFileName;
		ofdFileInput.OfdFileID = "123456";
		ofdFileInput.OfdFileDataBase64 = fileDataBase64;

		inputParam.ListOfdFileInput = new ArrayList<OfdPrinterFileInput>();
		inputParam.ListOfdFileInput.add(ofdFileInput);

		inputParam.PrinterParam = GetPrinterParam();

		return inputParam;
	}

	private static OfdPrinterParam GetPrinterParam() {
		OfdPrinterParam printerParam = new OfdPrinterParam();
		printerParam.IsAlignCenter = true;
		printerParam.IsRotation = false;
		printerParam.IsScaleToPaper = false;

		printerParam.PageCountPerPaper = 1;

		printerParam.PrinterName = null; // ӡƣΪգʹ÷ĬϵĴӡ
		return printerParam;
	}

	// endregion

	// region:5ȡԷƱ ӿڵʾ *************************************************
	static void OfdDataExtraction() {
		// ȡʾ
		System.out.println("OfdDataExtraction start");

		// ofdļ ע⣺ļʵ
		String ofdFileName = "Ʊ.ofd";

		// ofdӡ ַ ע⣺Ҫдʵķַ
		String serverUrl = "http://localhost:9600/OfdDataExtract";

		// 
		Map<String, String> params = new HashMap<String, String>();
		OfdExtractionInput inputParam = CreateOfdDataExtractParam(ofdFileName);

		Gson gson = new Gson();
		String paramValueJson = gson.toJson(inputParam);
		params.put("input", paramValueJson);

		// web api 
		String httpResponse = post_method(params, serverUrl);

		//  jsonл
		OfdExtractionOutput outParam = gson.fromJson(httpResponse, OfdExtractionOutput.class);

		OfdDataExtractionInfo fileOutput = outParam.ListOfdFileInfo.get(0);
		if (fileOutput.OK) {
			System.out.println("ȡɹ");

			// Ʊ
			InvoiceData invoiceData = gson.fromJson(fileOutput.DataExtraction, InvoiceData.class);
			System.out.println("Ʊݣ" + fileOutput.DataExtraction);

		} else {
			System.out.println("ȡʧܣ" + fileOutput.Message);
		}

		System.out.println("OfdDataExtraction end");
	}

	private static OfdExtractionInput CreateOfdDataExtractParam(String ofdFileName) {

		OfdExtractionInput extractionInput = new OfdExtractionInput();
		extractionInput.ClientData = "ȡ";

		String fileDataBase64 = GetFileBase64(ofdFileName);
		;

		OfdExtractionFileInput fileInfo = new OfdExtractionFileInput();
		fileInfo.FileName = ofdFileName;
		fileInfo.OfdFileID = "123456";
		fileInfo.OfdFileDataBase64 = fileDataBase64;

		fileInfo.OfdFileType = "ֵ˰ͨƱ";
		fileInfo.DataExtractionType = "ƱϢ";
		extractionInput.ListOfdFileInput = new ArrayList<OfdExtractionFileInput>();
		extractionInput.ListOfdFileInput.add(fileInfo);

		return extractionInput;
	}

	// endregion

	// region:6֤ǩ ӿڵʾ *************************************************
	static void OfdVerification() {
		// ȡʾ
		System.out.println("OfdVerification start");

		// ofdļ ע⣺ļʵ
		//String ofdFileName = "Ʊ.ofd";
		String ofdFileName = "Ʊ (ǩ֤鱻޸).ofd";
		
		// ofdӡ ַ ע⣺Ҫдʵķַ
		String serverUrl = "http://localhost:9700/OfdVerification";

		// 
		Map<String, String> params = new HashMap<String, String>();
		OfdVerificationInput inputParam = CreateOfdVerificationParam(ofdFileName);

		Gson gson = new Gson();
		String paramValueJson = gson.toJson(inputParam);
		params.put("input", paramValueJson);

		// web api 
		String httpResponse = post_method(params, serverUrl);

		//  jsonл
		OfdVerificationOutput outParam = gson.fromJson(httpResponse, OfdVerificationOutput.class);

		OfdDataVerificationInfo fileOutput = outParam.ListOfdFileInfo.get(0);
		if (fileOutput.OK) {
			System.out.println("ofdļ֤ǩ³ɹ");
		} else {
			System.out.println("ofdļ֤ǩʧܣ" + fileOutput.Message);
		}

		System.out.println("OfdVerification end");
	}
	
	 private static OfdVerificationInput CreateOfdVerificationParam(String ofdFileName)
     {
         OfdVerificationInput extractionInput = new OfdVerificationInput();
         extractionInput.ClientData = "֤";
        
         String fileDataBase64 = GetFileBase64(ofdFileName);

         OfdVerificationFileInput fileInfo = new OfdVerificationFileInput();
         fileInfo.FileName = ofdFileName;
         fileInfo.OfdFileID ="123456";
         fileInfo.OfdFileDataBase64 = fileDataBase64;

         extractionInput.ListOfdFileInput = new ArrayList<OfdVerificationFileInput>();
         extractionInput.ListOfdFileInput.add(fileInfo);
         
         return extractionInput;
     }
	 
	// endregion

	// region 
	static String GetFileBase64(String fileName) {
		try {
			FileInputStream in = new FileInputStream(fileName);
			byte[] fileBuffer = in.readAllBytes();

			Base64.Encoder encoder = Base64.getEncoder();
			String encodedText = encoder.encodeToString(fileBuffer);
			in.close();

			return encodedText;
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	public static boolean deleteFile(String fileName) {
		File file = new File(fileName);
		// ļ·Ӧļڣһļֱɾ
		if (file.exists() && file.isFile()) {
			if (file.delete()) {
				// System.out.println("ɾļ" + fileName + "ɹ");
				return true;
			} else {
				// System.out.println("ɾļ" + fileName + "ʧܣ");
				return false;
			}
		} else {
			// System.out.println("ɾļʧܣ" + fileName + "ڣ");
			return false;
		}
	}

	private static String post_method(Map<String, String> params, String serverUrl) {
		DefaultHttpClient httpclient = new DefaultHttpClient();
		String body = null;
		HttpPost post = postForm(params, serverUrl);
		body = invoke(httpclient, post);
		httpclient.getConnectionManager().shutdown();
		return body;
	}

	private static HttpPost postForm(Map<String, String> params, String serverUrl) {
		HttpPost httpost = new HttpPost(serverUrl); // Լص(Ȩ)URLַ
		List<NameValuePair> nvps = new ArrayList<NameValuePair>();
		Set<String> keySet = params.keySet();
		for (String key : keySet) {
			nvps.add(new BasicNameValuePair(key, params.get(key)));
		}
		try {
			httpost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8));
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		return httpost;
	}

	private static String invoke(DefaultHttpClient httpclient, HttpUriRequest httpost) {
		HttpResponse response = sendRequest(httpclient, httpost);
		String body = paseResponse(response);
		return body;
	}

	private static HttpResponse sendRequest(DefaultHttpClient httpclient, HttpUriRequest httpost) {
		HttpResponse response = null;
		try {
			response = httpclient.execute(httpost);
		} catch (ClientProtocolException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return response;
	}

	private static String paseResponse(HttpResponse response) {
		HttpEntity entity = response.getEntity();

		String body = null;
		try {
			body = EntityUtils.toString(entity, "utf-8");
		} catch (ParseException e) {
			// TODO Զɵ catch 
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Զɵ catch 
			e.printStackTrace();
		}
		return body;
	}
	// endregion
}
